Scriptname CHHorseWhistleEffectScript extends ActiveMagicEffect
{Script by Alek (mitchalek@yahoo.com).
Attached to a whistle magic effect.}

Import Utility
Import Game
Import Math
Import Debug

ReferenceAlias property Alias_Horse auto
CHPlayerAliasScript property PlayerScript auto
GlobalVariable property CHHorseWhistleActive auto
GlobalVariable property CHAnimationsEnable auto
Sound property CHHorseWhistleShortSM auto
Sound property CHHorseWhistleMediumSM auto
Sound property CHHorseWhistleLongSM auto
Package property CHPlayerHorseWhistlePackage auto
FormList property CHRidableWorldList auto
Message property CHErrorLocationMessage auto
Message property CHErrorNoHorseMessage auto
Message property CHErrorHorseDisabledMessage auto

Event OnEffectStart(Actor akTarget, Actor akCaster)
	
	if akCaster != GetPlayer()
		dispel()
		return
	endif

	If Game.GetModByName("Devious Devices - Assets.esm") !=255
		If akCaster.WornHasKeyword(Game.GetFormFromFile(0x007EB8, "Devious Devices - Assets.esm") as Keyword) ; zad_DeviousGag
			Debug.Notification("I can't whistle while I'm gagged")
			Dispel()
			Return
		EndIf
	EndIf

	Actor HorseRef = Alias_Horse.GetActorReference()
	; Validity checks
	if !HorseRef
		CHErrorNoHorseMessage.Show()
		dispel()
		return
	endif
	if HorseRef.IsDeleted() || HorseRef.IsDead()
		CHErrorNoHorseMessage.Show()
		Dispel()
		return
	endif
	if HorseRef.IsDisabled()
		CHErrorHorseDisabledMessage.Show()
		Dispel()
		return
	endif
	if !CHRidableWorldList.HasForm(akCaster.GetWorldSpace()) || akCaster.GetWorldSpace() != HorseRef.GetWorldSpace()
		CHErrorLocationMessage.Show()
		Dispel()
		return
	endif

	Sound Whistle
	Topic Comment
	float distance = akCaster.GetDistance(HorseRef)
	bool Animate = CHAnimationsEnable.GetValue() as Bool

	if Animate
		akCaster.SetGhost(True)
		DisablePlayerControls(abMovement = false, abFighting = false, abCamSwitch = true, abLooking = akCaster.GetAnimationVariableBool("i1stPerson"), abSneaking = true, abMenu = true, abActivate = true, abJournalTabs = false)
		SetPlayerAIDriven(True)
	endif

	; Whistle selection
	if distance > 4096
		Whistle = CHHorseWhistleLongSM
	elseif distance > 2048
		Whistle = CHHorseWhistleMediumSM
	else
		Whistle = CHHorseWhistleShortSM
	endif
	
	; Animate and whistle
	if Animate
		SendAnimationEvent(akCaster, "ShoutStart")
		Wait(0.6)
		if akCaster.IsWeaponDrawn()
			SendAnimationEvent(akCaster, "CombatReady_BreathExhaleLong")
		else
			SendAnimationEvent(akCaster, "MT_BreathExhaleLong")
		endif
	endif

	Whistle.PlayAndWait(akCaster)
	
	if Animate
		SendAnimationEvent(akCaster, "ShoutStop")

		SetPlayerAIDriven(False)
		EnablePlayerControls()
		akCaster.SetGhost(False)
	endif

	CHHorseWhistleActive.Mod(1)
	
	if HorseRef.GetCurrentPackage() != CHPlayerHorseWhistlePackage
		HorseRef.EvaluatePackage()
	endif

	if !HorseRef.HasLOS(akCaster)
		PlayerScript.RegisterForSingleLOSGain(HorseRef, akCaster)
	endif

	dispel()
EndEvent
